package ur;

import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class AddDevicesScreen extends Form implements CommandListener
{
    public AddDevicesScreen()
    {
	super("Add Devices");
        setCommandListener(this);
	refresh();
    }

    public void refresh()
    {
	while (size() > 0)
	    delete(0);

	mIndex = 0;
	mVCRIndex = -1;
	mPS2Index = -1;
	mAmpIndex = -1;
	mDVDIndex = -1;

	mDevices = new ChoiceGroup("Devices", ChoiceGroup.MULTIPLE);
	if (!Devices.mAmpAdded)
	{
	    mAmpIndex = mIndex++;
	    mDevices.append("Amp", null);
	}
	if (!Devices.mVCRAdded)
	{
	    mVCRIndex = mIndex++;
	    mDevices.append("VCR", null);
	}
	if (!Devices.mDVDAdded)
	{
	    mDVDIndex = mIndex++;
	    mDevices.append("DVD", null);
	}
	if (!Devices.mPS2Added)
	{
	    mPS2Index = mIndex++;
	    mDevices.append("PS2", null);
	}

	append(mDevices);
	if (!mInit)
	{
	    addCommand(mBack);
	    addCommand(mHome);
	}
	else
	    mInit = false;

	addCommand(mAdd);
    }

    public void commandAction(Command c, Displayable d)
    {
        if (c == mBack)
        {
            Main.goDevices();
        }
        else if (c == mAdd)
        {
	    // Add the devices
	    for (int i = 0; i < mIndex; ++i)
	    {
		if (mDevices.isSelected(i))
		{
		    Devices.mNumDevicesAdded++;

		    if (i == mAmpIndex)
		    {
			Devices.mAmpAdded = true;
			Devices.mSetupPages.addElement(new AmpSetup());

			// Add the other setup pages if other devices have
			// already been added
			if (Devices.mVCRAdded)
			    Devices.mSetupPages.addElement(new DeviceSetup("VCR"));
			if (Devices.mDVDAdded)
			    Devices.mSetupPages.addElement(new DeviceSetup("DVD"));
			if (Devices.mPS2Added)
			    Devices.mSetupPages.addElement(new DeviceSetup("PS2"));
		    }
		    else if (i == mVCRIndex)
		    {
			Devices.mVCRAdded = true;
			Devices.mSetupPages.addElement(new DeviceSetup("VCR"));
		    }
		    else if (i == mPS2Index)
		    {
			Devices.mPS2Added = true;
			Devices.mSetupPages.addElement(new DeviceSetup("PS2"));
		    }
		    else if (i == mDVDIndex)
		    {
			Devices.mDVDAdded = true;
			Devices.mSetupPages.addElement(new DeviceSetup("DVD"));
		    }
		}
	    }
	    Devices.mSetupPages.addElement(new RemoteScreen());
	    
            Main.updateDevices();
            Main.goNextSetup();
        }
	else if (c == mHome)
            Main.goHome();    
    }

    private ChoiceGroup mDevices;
    private Command     mHome = new Command("Home", Command.SCREEN, 1);
    private Command     mBack = new Command("Back", Command.BACK, 1);
    private Command     mAdd  = new Command("Add",  Command.ITEM, 1);

    private int mIndex    = 0;
    private int mVCRIndex = -1;
    private int mPS2Index = -1;
    private int mAmpIndex = -1;
    private int mDVDIndex = -1;
    private boolean mInit = true;
}
