package ur;

import javax.microedition.lcdui.*;

public class AmpSetup extends Form
    implements CommandListener, ItemStateListener
{
    public AmpSetup()
    {
	super("Amp Setup");
	setItemStateListener(this);
	setCommandListener(this);
	addCommand(mDone);

	mSpeakerOption.append("0: use TV Speakers", null);
	mSpeakerOption.append("2 Front", null);
	mSpeakerOption.append("2 Front, Center", null);
	mSpeakerOption.append("2 Front, Sub Woofer", null);
	mSpeakerOption.append("2 Front, Center, Sub Woofer", null);
	mSpeakerOption.append("2 Front, 2 Satellite", null);
	mSpeakerOption.append("2 Front, 2 Sat., Center", null);
	mSpeakerOption.append("2 Front, 2 Sat., Sub Woofer", null);
	mSpeakerOption.append("2 Front, 2 Sat., Center, Sub Woofer", null);
	append(mSpeakerOption);

	mChannelQuestion.append("Yes", null);
	mChannelQuestion.append("No",  null);
	
	mVideoQuestion.append("No",  null);
	mVideoQuestion.append("Yes", null);

	append(mChannelQuestion);
	itemStateChanged(mChannelQuestion);
	itemStateChanged(mSpeakerOption);
    }

    public void itemStateChanged(Item item)
    {
	if (item == mChannelQuestion)
	{
	    if (mChannelQuestion.getSelectedIndex() == 0)
	    {
		if (size() == 2)
		    append(mChannel);
		else
		    set(2, mChannel);
	    }
	    else
	    {
		if (size() == 2)
		    append(mVideoQuestion);
		else
		    set(2, mVideoQuestion);
	    }
	}

	if (item == mSpeakerOption)
	{
	    resetSpeakerOptions();

	    if (mSpeakerOption.getSelectedIndex() == 0)
		Devices.mTVSpeakersOnly = true;
	    else
	    {
		Devices.mFrontSpeakersAdded = true;
		Devices.mTVSpeakersOnly = false;
	    
		switch (mSpeakerOption.getSelectedIndex())
		{
		case 2:
		    Devices.mCenterSpeakerAdded = true;
		    break;
		case 3:
		    Devices.mSubWooferAdded = true;
		    break;
		case 4:
		    Devices.mCenterSpeakerAdded = true;
		    Devices.mSubWooferAdded = true;
		    break;
		case 5:
		    Devices.mSatelliteSpeakersAdded = true;
		    break;
		case 6:
		    Devices.mSatelliteSpeakersAdded = true;
		    Devices.mCenterSpeakerAdded = true;
		    break;
		case 7:
		    Devices.mSatelliteSpeakersAdded = true;
		    Devices.mSubWooferAdded = true;
		    break;
		case 8:
		    Devices.mSatelliteSpeakersAdded = true;
		    Devices.mSubWooferAdded = true;
		    Devices.mCenterSpeakerAdded = true;
		    break;
		default:
		    break;
		}
	    }
	}
    }

    public void resetSpeakerOptions()
    {
	Devices.mTVSpeakersOnly = false;
	Devices.mFrontSpeakersAdded = false;
	Devices.mSatelliteSpeakersAdded = false;
	Devices.mCenterSpeakerAdded = false;
	Devices.mSubWooferAdded = false;
    }

    public void commandAction(Command c, Displayable d)
    {
	if (c == mDone)
	    Main.goNextSetup();
    }

    private ChoiceGroup mSpeakerOption = new ChoiceGroup(
	"Select the speaker configuration",
	ChoiceGroup.EXCLUSIVE);
    private ChoiceGroup mChannelQuestion = new ChoiceGroup(
	"Does a TV need to be set to a particular channel?",
	ChoiceGroup.EXCLUSIVE);
    private Gauge mChannel = new Gauge("Channel", true, 99, 5);
    private ChoiceGroup mVideoQuestion = new ChoiceGroup(
	"Does the TV need to be in TV/Video?",
	ChoiceGroup.EXCLUSIVE);
    private Command mDone = new Command("Done", Command.SCREEN, 1);
}
