package ur;

import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class HomeScreen extends Form implements ItemStateListener, CommandListener
{
    public HomeScreen() throws IOException
    {
	super("Home");
        setItemStateListener(this);
	setCommandListener(this);

        updateDevices();

	append(mMediaType);
	append(mChannelT);
	append(mChannelG);
	append(mVolume);
	addCommand(mMenu);
	addCommand(mPower);
	addCommand(mMute);
    }

    public void updateDevices()
    {
        boolean defaultAdded = false;

        while (mMediaType.size() > 0)
            mMediaType.delete(0);

        int index = 0;
        if (Devices.mVCRAdded)
        {
            mMediaType.append("VCR", null);
            mDeviceImages.put(new Integer(index++), mVCRImage);
            if (!defaultAdded)
            {
                setDeviceImage(mVCRImage);
                defaultAdded = true;
            }
        }
        if (Devices.mDVDAdded)
        {
            mMediaType.append("DVD", null);
            mDeviceImages.put(new Integer(index++), mDVDImage);
            if (!defaultAdded)
            {
                setDeviceImage(mDVDImage);
                defaultAdded = true;
            }
        }
        if (Devices.mPS2Added)
        {
            mMediaType.append("PS2", null);
            mDeviceImages.put(new Integer(index++), mPS2Image);
            if (!defaultAdded)
            {
                setDeviceImage(mPS2Image);
                defaultAdded = true;
            }
        }
        if (Devices.mAmpAdded)
        {
            mMediaType.append("Amp", null);
            mDeviceImages.put(new Integer(index++), mAmpImage);
            if (!defaultAdded)
            {
                setDeviceImage(mAmpImage);
                defaultAdded = true;
            }
        }

        if (mMediaType.size() > 0)
            mMediaType.setSelectedIndex(0, true);
    }

    private void setDeviceImage(Image image)
    {
        if (get(0) instanceof ImageItem)
            delete(0);
        insert(0, new ImageItem(null, image, ImageItem.LAYOUT_DEFAULT, null));
    }

    public void itemStateChanged(Item item)
    {
        if (item == mMediaType)
        {
            Integer i = new Integer(mMediaType.getSelectedIndex());
            Image img = (Image)mDeviceImages.get(i);
            if (img != null)
                set(0, new ImageItem(null, img, ImageItem.LAYOUT_DEFAULT, null));
        }
	if (item == mChannelT)
	{
	    if (mChannelT.getString() != "")
		mChannelG.setValue(Integer.parseInt(mChannelT.getString()));
	    else
		mChannelG.setValue(0);
	}
	if (item == mChannelG)
	  mChannelT.setString("");
    }

    public void commandAction(Command c, Displayable d)
    {
	if (c == mPower)
	    Main.exit();
	else if (c == mMenu)
	    Main.goDevices();
    }

    private ChoiceGroup mMediaType = new ChoiceGroup("Media Type", ChoiceGroup.EXCLUSIVE);
    private TextField   mChannelT = new TextField("Channel #", "", 2, TextField.NUMERIC);
    private Gauge       mChannelG = new Gauge("Channel", true, 99, 35);
    private Gauge       mVolume   = new Gauge("Volume", true, 99, 50);
    private Command     mPower    = new Command("Off", Command.SCREEN, 1);
    private Command     mMute     = new Command("Mute",  Command.SCREEN, 1);
    private Command     mMenu     = new Command("MENU",  Command.SCREEN, 1);

    private Image mVCRImage = Image.createImage("/vcr.png");
    private Image mDVDImage = Image.createImage("/dvd.png");
    private Image mPS2Image = Image.createImage("/ps2.png");
    private Image mAmpImage = Image.createImage("/amp.png");

    private Hashtable mDeviceImages = new Hashtable();
}
