package ur;

import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class RemoteScreen extends Form implements CommandListener, ItemStateListener
{
    public RemoteScreen()
    {
	super("Remote Options");
	setCommandListener(this);
	setItemStateListener(this);
	refresh();
    }

    public void refresh()
    {
	while (size() > 0)
	    delete(0);

	if (!mInit)
	{
	    addCommand(mHome);
	    addCommand(mBack);
	}
	else
	    mInit = false;

	addCommand(mDone);

	mAddIndex = 0;
	mRemoveIndex = 0;
	mTVIndex = -1;
	mVCRIndex = -1;
	mAmpIndex = -1;
	mDVDIndex = -1;
	mPS2Index = -1;

	mLabel = new StringItem("Upon remote startup, turn on these devices:",null);
	mTurnOn = new ChoiceGroup(null, ChoiceGroup.MULTIPLE);
	if (!Devices.mTVTurnsOn)
	{
	    mTurnOn.append("TV", null);
	    mTVIndex = mAddIndex++;
	}
	if (Devices.mVCRAdded && !Devices.mVCRTurnsOn)
	{
	    mTurnOn.append("VCR", null);
	    mVCRIndex = mAddIndex++;
	}
	if (Devices.mAmpAdded && !Devices.mAmpTurnsOn)
	{
	    mTurnOn.append("Amplifier", null);
	    mAmpIndex = mAddIndex++;
	}
	if (Devices.mDVDAdded && !Devices.mDVDTurnsOn)
	{
	    mTurnOn.append("DVD", null);
	    mDVDIndex = mAddIndex++;
	}
	if (Devices.mPS2Added && !Devices.mPS2TurnsOn)
	{
	    mTurnOn.append("PS2", null);
	    mPS2Index = mAddIndex++;
	}
	
	append(mLabel);
	append(mTurnOn);

	mLabel2 = new StringItem("Remove automatic startup for these devices:",null);

	mTurnOff = new ChoiceGroup(null, ChoiceGroup.MULTIPLE);
	if (Devices.mTVTurnsOn)
	{
	    mTurnOff.append("TV", null);
	    mTVIndex = mRemoveIndex++;
	}
	if (Devices.mVCRAdded && Devices.mVCRTurnsOn)
	{
	    mTurnOff.append("VCR", null);
	    mVCRIndex = mRemoveIndex++;
	}
	if (Devices.mAmpAdded && Devices.mAmpTurnsOn)
	{
	    mTurnOff.append("Amplifier", null);
	    mAmpIndex = mRemoveIndex++;
	}
	if (Devices.mDVDAdded && Devices.mDVDTurnsOn)
	{
	    mTurnOff.append("DVD", null);
	    mDVDIndex = mRemoveIndex++;
	}
	if (Devices.mPS2Added && Devices.mPS2TurnsOn)
	{
	    mTurnOff.append("PS2", null);
	    mPS2Index = mRemoveIndex++;
	}
	
	append(mLabel2);
	append(mTurnOff);
    }

    public void itemStateChanged(Item item)
    {
	if (item == mTurnOn)
	{
	    for(int i=0; i<mAddIndex; i++)
	    {
		if (mTurnOn.isSelected(i))
		{
		    if (i == mTVIndex)
			Devices.mTVTurnsOn = true;
		    if (i == mAmpIndex)
			Devices.mAmpTurnsOn = true;
		    if (i == mVCRIndex)
			Devices.mVCRTurnsOn = true;
		    if (i == mDVDIndex)
			Devices.mDVDTurnsOn = true;
		    if (i == mPS2Index)
			Devices.mPS2TurnsOn = true;
		}
	    }
	}

	if (item == mTurnOff)
	{
	    for(int i=0; i<mRemoveIndex; i++)
	    {
		if (mTurnOff.isSelected(i))
		{
		    if (i == mTVIndex)
			Devices.mTVTurnsOn = false;
		    if (i == mAmpIndex)
			Devices.mAmpTurnsOn = false;
		    if (i == mVCRIndex)
			Devices.mVCRTurnsOn = false;
		    if (i == mDVDIndex)
			Devices.mDVDTurnsOn = false;
		    if (i == mPS2Index)
			Devices.mPS2TurnsOn = false;
		}
	    }
	}
    }

    public void commandAction(Command c, Displayable d)
    {
	if (c == mDone)
	    Main.goHome();
        if (c == mBack)
            Main.goDevices();
	if (c == mHome)
            Main.goHome();
    }

    private boolean     mInit = true;
    private ChoiceGroup mTurnOn;
    private StringItem  mLabel;
    private ChoiceGroup mTurnOff;
    private StringItem  mLabel2;
    private Command     mDone = new Command("Done", Command.SCREEN, 1);
    private Command     mHome = new Command("Home", Command.SCREEN, 1);
    private Command     mBack = new Command("Back", Command.SCREEN, 1);

    private int mAddIndex = 0;
    private int mRemoveIndex = 0;
    private int mTVIndex = -1;
    private int mVCRIndex = -1;
    private int mAmpIndex = -1;
    private int mDVDIndex = -1;
    private int mPS2Index = -1;
}
